Index: src/includes/classes/Smarty/sysplugins/smarty_internal_configfileparser.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_configfileparser.php	(revision 54b5657ad2e80eb6f9bf910415d8a992a8b6d777)
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_configfileparser.php	(revision )
@@ -702,194 +727,147 @@
         $yytos->stateno = $yyNewState;
         $yytos->major = $yyMajor;
         $yytos->minor = $yypMinor;
-        array_push($this->yystack, $yytos);
+        $this->yystack[] = $yytos;
         if ($this->yyTraceFILE && $this->yyidx > 0) {
-            fprintf($this->yyTraceFILE, "%sShift %d\n", $this->yyTracePrompt,
-                    $yyNewState);
+            fprintf($this->yyTraceFILE, "%sShift %d\n", $this->yyTracePrompt, $yyNewState);
             fprintf($this->yyTraceFILE, "%sStack:", $this->yyTracePrompt);
             for ($i = 1; $i <= $this->yyidx; $i ++) {
-                fprintf($this->yyTraceFILE, " %s",
-                        $this->yyTokenName[$this->yystack[$i]->major]);
+                fprintf($this->yyTraceFILE, " %s", $this->yyTokenName[$this->yystack[$i]->major]);
             }
             fwrite($this->yyTraceFILE, "\n");
         }
     }
 
-    public static $yyRuleInfo = array(
-        array('lhs' => 20, 'rhs' => 2),
-        array('lhs' => 21, 'rhs' => 1),
-        array('lhs' => 22, 'rhs' => 2),
-        array('lhs' => 22, 'rhs' => 0),
-        array('lhs' => 24, 'rhs' => 5),
-        array('lhs' => 24, 'rhs' => 6),
-        array('lhs' => 23, 'rhs' => 2),
-        array('lhs' => 23, 'rhs' => 2),
-        array('lhs' => 23, 'rhs' => 0),
-        array('lhs' => 26, 'rhs' => 3),
-        array('lhs' => 27, 'rhs' => 1),
-        array('lhs' => 27, 'rhs' => 1),
-        array('lhs' => 27, 'rhs' => 1),
-        array('lhs' => 27, 'rhs' => 1),
-        array('lhs' => 27, 'rhs' => 1),
-        array('lhs' => 27, 'rhs' => 3),
-        array('lhs' => 27, 'rhs' => 2),
-        array('lhs' => 27, 'rhs' => 1),
-        array('lhs' => 27, 'rhs' => 1),
-        array('lhs' => 25, 'rhs' => 1),
-        array('lhs' => 25, 'rhs' => 2),
-        array('lhs' => 25, 'rhs' => 3),
-    );
+    public static $yyRuleInfo = array(array(0 => 20, 1 => 2), array(0 => 21, 1 => 1), array(0 => 22, 1 => 2),
+        array(0 => 22, 1 => 0), array(0 => 24, 1 => 5), array(0 => 24, 1 => 6), array(0 => 23, 1 => 2),
+        array(0 => 23, 1 => 2), array(0 => 23, 1 => 0), array(0 => 26, 1 => 3), array(0 => 27, 1 => 1),
+        array(0 => 27, 1 => 1), array(0 => 27, 1 => 1), array(0 => 27, 1 => 1), array(0 => 27, 1 => 1),
+        array(0 => 27, 1 => 3), array(0 => 27, 1 => 2), array(0 => 27, 1 => 1), array(0 => 27, 1 => 1),
+        array(0 => 25, 1 => 1), array(0 => 25, 1 => 2), array(0 => 25, 1 => 3),);
 
-    public static $yyReduceMap = array(
-        0  => 0,
-        2  => 0,
-        3  => 0,
-        19 => 0,
-        20 => 0,
-        21 => 0,
-        1  => 1,
-        4  => 4,
-        5  => 5,
-        6  => 6,
-        7  => 7,
-        8  => 8,
-        9  => 9,
-        10 => 10,
-        11 => 11,
-        12 => 12,
-        13 => 13,
-        14 => 14,
-        15 => 15,
-        16 => 16,
-        17 => 17,
-        18 => 17,
-    );
+    public static $yyReduceMap = array(0  => 0, 2 => 0, 3 => 0, 19 => 0, 20 => 0, 21 => 0, 1 => 1, 4 => 4, 5 => 5,
+                                       6  => 6, 7 => 7, 8 => 8, 9 => 9, 10 => 10, 11 => 11, 12 => 12, 13 => 13,
+                                       14 => 14, 15 => 15, 16 => 16, 17 => 17, 18 => 17,);
 
-    #line 131 "smarty_internal_configfileparser.y"
+    #line 261 "../smarty/lexer/smarty_internal_configfileparser.y"
     function yy_r0()
     {
         $this->_retvalue = null;
     }
-    #line 675 "smarty_internal_configfileparser.php"
-    #line 136 "smarty_internal_configfileparser.y"
+
+    #line 266 "../smarty/lexer/smarty_internal_configfileparser.y"
     function yy_r1()
     {
         $this->add_global_vars($this->yystack[$this->yyidx + 0]->minor);
         $this->_retvalue = null;
     }
-    #line 680 "smarty_internal_configfileparser.php"
-    #line 149 "smarty_internal_configfileparser.y"
+
+    #line 280 "../smarty/lexer/smarty_internal_configfileparser.y"
     function yy_r4()
     {
         $this->add_section_vars($this->yystack[$this->yyidx + - 3]->minor, $this->yystack[$this->yyidx + 0]->minor);
         $this->_retvalue = null;
     }
-    #line 686 "smarty_internal_configfileparser.php"
-    #line 154 "smarty_internal_configfileparser.y"
+
+    #line 285 "../smarty/lexer/smarty_internal_configfileparser.y"
     function yy_r5()
     {
-        if ($this->smarty->config_read_hidden) {
+        if ($this->configReadHidden) {
             $this->add_section_vars($this->yystack[$this->yyidx + - 3]->minor, $this->yystack[$this->yyidx + 0]->minor);
         }
         $this->_retvalue = null;
     }
-    #line 694 "smarty_internal_configfileparser.php"
-    #line 162 "smarty_internal_configfileparser.y"
+
+    #line 293 "../smarty/lexer/smarty_internal_configfileparser.y"
     function yy_r6()
     {
         $this->_retvalue = $this->yystack[$this->yyidx + - 1]->minor;
     }
-    #line 699 "smarty_internal_configfileparser.php"
-    #line 166 "smarty_internal_configfileparser.y"
+
+    #line 297 "../smarty/lexer/smarty_internal_configfileparser.y"
     function yy_r7()
     {
         $this->_retvalue = array_merge($this->yystack[$this->yyidx + - 1]->minor, Array($this->yystack[$this->yyidx + 0]->minor));
     }
-    #line 704 "smarty_internal_configfileparser.php"
-    #line 170 "smarty_internal_configfileparser.y"
+
+    #line 301 "../smarty/lexer/smarty_internal_configfileparser.y"
     function yy_r8()
     {
         $this->_retvalue = Array();
     }
-    #line 709 "smarty_internal_configfileparser.php"
-    #line 176 "smarty_internal_configfileparser.y"
+
+    #line 307 "../smarty/lexer/smarty_internal_configfileparser.y"
     function yy_r9()
     {
-        $this->_retvalue = Array("key" => $this->yystack[$this->yyidx + - 2]->minor, "value" => $this->yystack[$this->yyidx + 0]->minor);
+        $this->_retvalue = Array("key"   => $this->yystack[$this->yyidx + - 2]->minor,
+                                 "value" => $this->yystack[$this->yyidx + 0]->minor);
     }
-    #line 714 "smarty_internal_configfileparser.php"
-    #line 181 "smarty_internal_configfileparser.y"
+
+    #line 312 "../smarty/lexer/smarty_internal_configfileparser.y"
     function yy_r10()
     {
         $this->_retvalue = (float) $this->yystack[$this->yyidx + 0]->minor;
     }
-    #line 719 "smarty_internal_configfileparser.php"
-    #line 185 "smarty_internal_configfileparser.y"
+
+    #line 316 "../smarty/lexer/smarty_internal_configfileparser.y"
     function yy_r11()
     {
         $this->_retvalue = (int) $this->yystack[$this->yyidx + 0]->minor;
     }
-    #line 724 "smarty_internal_configfileparser.php"
-    #line 189 "smarty_internal_configfileparser.y"
+
+    #line 320 "../smarty/lexer/smarty_internal_configfileparser.y"
     function yy_r12()
     {
         $this->_retvalue = $this->parse_bool($this->yystack[$this->yyidx + 0]->minor);
     }
-    #line 729 "smarty_internal_configfileparser.php"
-    #line 193 "smarty_internal_configfileparser.y"
+
+    #line 324 "../smarty/lexer/smarty_internal_configfileparser.y"
     function yy_r13()
     {
         $this->_retvalue = self::parse_single_quoted_string($this->yystack[$this->yyidx + 0]->minor);
     }
-    #line 734 "smarty_internal_configfileparser.php"
-    #line 197 "smarty_internal_configfileparser.y"
+
+    #line 328 "../smarty/lexer/smarty_internal_configfileparser.y"
     function yy_r14()
     {
         $this->_retvalue = self::parse_double_quoted_string($this->yystack[$this->yyidx + 0]->minor);
     }
-    #line 739 "smarty_internal_configfileparser.php"
-    #line 201 "smarty_internal_configfileparser.y"
+
+    #line 332 "../smarty/lexer/smarty_internal_configfileparser.y"
     function yy_r15()
     {
         $this->_retvalue = self::parse_tripple_double_quoted_string($this->yystack[$this->yyidx + - 1]->minor);
     }
-    #line 744 "smarty_internal_configfileparser.php"
-    #line 205 "smarty_internal_configfileparser.y"
+
+    #line 336 "../smarty/lexer/smarty_internal_configfileparser.y"
     function yy_r16()
     {
         $this->_retvalue = '';
     }
-    #line 749 "smarty_internal_configfileparser.php"
-    #line 209 "smarty_internal_configfileparser.y"
+
+    #line 340 "../smarty/lexer/smarty_internal_configfileparser.y"
     function yy_r17()
     {
         $this->_retvalue = $this->yystack[$this->yyidx + 0]->minor;
     }
 
-    #line 754 "smarty_internal_configfileparser.php"
-
     private $_retvalue;
 
     public function yy_reduce($yyruleno)
     {
-        $yymsp = $this->yystack[$this->yyidx];
-        if ($this->yyTraceFILE && $yyruleno >= 0
-            && $yyruleno < count(self::$yyRuleName)
-        ) {
-            fprintf($this->yyTraceFILE, "%sReduce (%d) [%s].\n",
-                    $this->yyTracePrompt, $yyruleno,
-                    self::$yyRuleName[$yyruleno]);
+        if ($this->yyTraceFILE && $yyruleno >= 0 && $yyruleno < count(self::$yyRuleName)) {
+            fprintf($this->yyTraceFILE, "%sReduce (%d) [%s].\n", $this->yyTracePrompt, $yyruleno, self::$yyRuleName[$yyruleno]);
         }
 
         $this->_retvalue = $yy_lefthand_side = null;
-        if (array_key_exists($yyruleno, self::$yyReduceMap)) {
+        if (isset(self::$yyReduceMap[$yyruleno])) {
             // call the action
             $this->_retvalue = null;
             $this->{'yy_r' . self::$yyReduceMap[$yyruleno]}();
             $yy_lefthand_side = $this->_retvalue;
         }
-        $yygoto = self::$yyRuleInfo[$yyruleno]['lhs'];
-        $yysize = self::$yyRuleInfo[$yyruleno]['rhs'];
+        $yygoto = self::$yyRuleInfo[$yyruleno][0];
+        $yysize = self::$yyRuleInfo[$yyruleno][1];
         $this->yyidx -= $yysize;
         for ($i = $yysize; $i; $i --) {
             // pop all of the right-hand side parameters
@@ -924,12 +902,11 @@
 
     public function yy_syntax_error($yymajor, $TOKEN)
     {
-        #line 118 "smarty_internal_configfileparser.y"
+        #line 248 "../smarty/lexer/smarty_internal_configfileparser.y"
 
         $this->internalError = true;
         $this->yymajor = $yymajor;
         $this->compiler->trigger_config_file_error();
-        #line 816 "smarty_internal_configfileparser.php"
     }
 
     public function yy_accept()
@@ -938,20 +915,18 @@
             fprintf($this->yyTraceFILE, "%sAccept!\n", $this->yyTracePrompt);
         }
         while ($this->yyidx >= 0) {
-            $stack = $this->yy_pop_parser_stack();
+            $this->yy_pop_parser_stack();
         }
-        #line 110 "smarty_internal_configfileparser.y"
+        #line 241 "../smarty/lexer/smarty_internal_configfileparser.y"
 
         $this->successful = !$this->internalError;
         $this->internalError = false;
         $this->retvalue = $this->_retvalue;
-        //echo $this->retvalue."\n\n";
-        #line 833 "smarty_internal_configfileparser.php"
     }
 
     public function doParse($yymajor, $yytokenvalue)
     {
-        $yyerrorhit = 0; /* True if yymajor has invoked an error */
+        $yyerrorhit = 0;   /* True if yymajor has invoked an error */
 
         if ($this->yyidx === null || $this->yyidx < 0) {
             $this->yyidx = 0;
@@ -960,20 +935,17 @@
             $x->stateno = 0;
             $x->major = 0;
             $this->yystack = array();
-            array_push($this->yystack, $x);
+            $this->yystack[] = $x;
         }
         $yyendofinput = ($yymajor == 0);
 
         if ($this->yyTraceFILE) {
-            fprintf($this->yyTraceFILE, "%sInput %s\n",
-                    $this->yyTracePrompt, $this->yyTokenName[$yymajor]);
+            fprintf($this->yyTraceFILE, "%sInput %s\n", $this->yyTracePrompt, $this->yyTokenName[$yymajor]);
         }
 
         do {
             $yyact = $this->yy_find_shift_action($yymajor);
-            if ($yymajor < self::YYERRORSYMBOL &&
-                !$this->yy_is_expected_token($yymajor)
-            ) {
+            if ($yymajor < self::YYERRORSYMBOL && !$this->yy_is_expected_token($yymajor)) {
                 // force a syntax error
                 $yyact = self::YY_ERROR_ACTION;
             }
@@ -989,8 +961,7 @@
                 $this->yy_reduce($yyact - self::YYNSTATE);
             } elseif ($yyact == self::YY_ERROR_ACTION) {
                 if ($this->yyTraceFILE) {
-                    fprintf($this->yyTraceFILE, "%sSyntax Error!\n",
-                            $this->yyTracePrompt);
+                    fprintf($this->yyTraceFILE, "%sSyntax Error!\n", $this->yyTracePrompt);
                 }
                 if (self::YYERRORSYMBOL) {
                     if ($this->yyerrcnt < 0) {
@@ -999,16 +970,12 @@
                     $yymx = $this->yystack[$this->yyidx]->major;
                     if ($yymx == self::YYERRORSYMBOL || $yyerrorhit) {
                         if ($this->yyTraceFILE) {
-                            fprintf($this->yyTraceFILE, "%sDiscard input token %s\n",
-                                    $this->yyTracePrompt, $this->yyTokenName[$yymajor]);
+                            fprintf($this->yyTraceFILE, "%sDiscard input token %s\n", $this->yyTracePrompt, $this->yyTokenName[$yymajor]);
                         }
                         $this->yy_destructor($yymajor, $yytokenvalue);
                         $yymajor = self::YYNOCODE;
                     } else {
-                        while ($this->yyidx >= 0 &&
-                            $yymx != self::YYERRORSYMBOL &&
-                            ($yyact = $this->yy_find_shift_action(self::YYERRORSYMBOL)) >= self::YYNSTATE
-                        ) {
+                        while ($this->yyidx >= 0 && $yymx != self::YYERRORSYMBOL && ($yyact = $this->yy_find_shift_action(self::YYERRORSYMBOL)) >= self::YYNSTATE) {
                             $this->yy_pop_parser_stack();
                         }
                         if ($this->yyidx < 0 || $yymajor == 0) {
@@ -1040,3 +1007,4 @@
         } while ($yymajor != self::YYNOCODE && $this->yyidx >= 0);
     }
 }
+
Index: src/includes/classes/Smarty/sysplugins/smarty_internal_method_registerobject.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_method_registerobject.php	(revision )
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_method_registerobject.php	(revision )
@@ -0,0 +1,71 @@
+<?php
+
+/**
+ * Smarty Method RegisterObject
+ *
+ * Smarty::registerObject() method
+ *
+ * @package    Smarty
+ * @subpackage PluginsInternal
+ * @author     Uwe Tews
+ */
+class Smarty_Internal_Method_RegisterObject
+{
+    /**
+     * Valid for Smarty and template object
+     *
+     * @var int
+     */
+    public $objMap = 3;
+
+    /**
+     * Registers object to be used in templates
+     *
+     * @api  Smarty::registerObject()
+     * @link http://www.smarty.net/docs/en/api.register.object.tpl
+     *
+     * @param \Smarty_Internal_TemplateBase|\Smarty_Internal_Template|\Smarty $obj
+     * @param  string                                                         $object_name
+     * @param  object                                                         $object                     the
+     *                                                                                                    referenced
+     *                                                                                                    PHP object to
+     *                                                                                                    register
+     * @param  array                                                          $allowed_methods_properties list of
+     *                                                                                                    allowed
+     *                                                                                                    methods
+     *                                                                                                    (empty = all)
+     * @param  bool                                                           $format                     smarty
+     *                                                                                                    argument
+     *                                                                                                    format, else
+     *                                                                                                    traditional
+     * @param  array                                                          $block_methods              list of
+     *                                                                                                    block-methods
+     *
+     * @return \Smarty|\Smarty_Internal_Template
+     * @throws \SmartyException
+     */
+    public function registerObject(Smarty_Internal_TemplateBase $obj, $object_name, $object, $allowed_methods_properties = array(), $format = true, $block_methods = array())
+    {
+        $smarty = isset($obj->smarty) ? $obj->smarty : $obj;
+        // test if allowed methods callable
+        if (!empty($allowed_methods_properties)) {
+            foreach ((array) $allowed_methods_properties as $method) {
+                if (!is_callable(array($object, $method)) && !property_exists($object, $method)) {
+                    throw new SmartyException("Undefined method or property '$method' in registered object");
+                }
+            }
+        }
+        // test if block methods callable
+        if (!empty($block_methods)) {
+            foreach ((array) $block_methods as $method) {
+                if (!is_callable(array($object, $method))) {
+                    throw new SmartyException("Undefined method '$method' in registered object");
+                }
+            }
+        }
+        // register the object
+        $smarty->registered_objects[$object_name] = array($object, (array) $allowed_methods_properties,
+                                                          (boolean) $format, (array) $block_methods);
+        return $obj;
+    }
+}
\ No newline at end of file
Index: src/includes/classes/Smarty/sysplugins/smarty_internal_method_registercacheresource.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_method_registercacheresource.php	(revision )
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_method_registercacheresource.php	(revision )
@@ -0,0 +1,39 @@
+<?php
+
+/**
+ * Smarty Method RegisterCacheResource
+ *
+ * Smarty::registerCacheResource() method
+ *
+ * @package    Smarty
+ * @subpackage PluginsInternal
+ * @author     Uwe Tews
+ */
+class Smarty_Internal_Method_RegisterCacheResource
+{
+    /**
+     * Valid for Smarty and template object
+     *
+     * @var int
+     */
+    public $objMap = 3;
+
+    /**
+     * Registers a resource to fetch a template
+     *
+     * @api  Smarty::registerCacheResource()
+     * @link http://www.smarty.net/docs/en/api.register.cacheresource.tpl
+     *
+     * @param \Smarty_Internal_TemplateBase|\Smarty_Internal_Template|\Smarty $obj
+     * @param  string                                                         $name name of resource type
+     * @param \Smarty_CacheResource                                           $resource_handler
+     *
+     * @return \Smarty|\Smarty_Internal_Template
+     */
+    public function registerCacheResource(Smarty_Internal_TemplateBase $obj, $name, Smarty_CacheResource $resource_handler)
+    {
+        $smarty = isset($obj->smarty) ? $obj->smarty : $obj;
+        $smarty->registered_cache_resources[$name] = $resource_handler;
+        return $obj;
+    }
+}
\ No newline at end of file
Index: src/includes/classes/Smarty/sysplugins/smarty_internal_method_clearallcache.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_method_clearallcache.php	(revision )
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_method_clearallcache.php	(revision )
@@ -0,0 +1,40 @@
+<?php
+
+/**
+ * Smarty Method ClearAllCache
+ *
+ * Smarty::clearAllCache() method
+ *
+ * @package    Smarty
+ * @subpackage PluginsInternal
+ * @author     Uwe Tews
+ */
+class Smarty_Internal_Method_ClearAllCache
+{
+    /**
+     * Valid for Smarty object
+     *
+     * @var int
+     */
+    public $objMap = 1;
+
+    /**
+     * Empty cache folder
+     *
+     * @api  Smarty::clearAllCache()
+     * @link http://www.smarty.net/docs/en/api.clear.all.cache.tpl
+     *
+     * @param \Smarty  $smarty
+     * @param  integer $exp_time expiration time
+     * @param  string  $type     resource type
+     *
+     * @return integer number of cache files deleted
+     */
+    public function clearAllCache(Smarty $smarty, $exp_time = null, $type = null)
+    {
+        // load cache resource and call clearAll
+        $_cache_resource = Smarty_CacheResource::load($smarty, $type);
+        $_cache_resource->invalidLoadedCache($smarty);
+        return $_cache_resource->clearAll($smarty, $exp_time);
+    }
+}
\ No newline at end of file
Index: src/includes/classes/Smarty/sysplugins/smarty_internal_compile_shared_inheritance.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_compile_shared_inheritance.php	(revision )
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_compile_shared_inheritance.php	(revision )
@@ -0,0 +1,46 @@
+<?php
+/**
+ * Smarty Internal Plugin Compile Shared Inheritance
+ * Shared methods for {extends} and {block} tags
+ *
+ * @package    Smarty
+ * @subpackage Compiler
+ * @author     Uwe Tews
+ */
+
+/**
+ * Smarty Internal Plugin Compile Shared Inheritance Class
+ *
+ * @package    Smarty
+ * @subpackage Compiler
+ */
+class Smarty_Internal_Compile_Shared_Inheritance extends Smarty_Internal_CompileBase
+{
+    /**
+     * Register post compile callback to compile inheritance initialization code
+     *
+     * @param \Smarty_Internal_TemplateCompilerBase $compiler
+     * @param bool|false                            $initChildSequence if true force child template
+     */
+    public function registerInit(Smarty_Internal_TemplateCompilerBase $compiler, $initChildSequence = false)
+    {
+        if ($initChildSequence || !isset($compiler->_cache['inheritanceInit'])) {
+            $compiler->registerPostCompileCallback(array('Smarty_Internal_Compile_Shared_Inheritance', 'postCompile'),
+                                                   array($initChildSequence), 'inheritanceInit', $initChildSequence);
+
+            $compiler->_cache['inheritanceInit'] = true;
+        }
+    }
+
+    /**
+     * Compile inheritance initialization code as prefix
+     *
+     * @param \Smarty_Internal_TemplateCompilerBase $compiler
+     * @param bool|false                            $initChildSequence if true force child template
+     */
+    static function postCompile(Smarty_Internal_TemplateCompilerBase $compiler, $initChildSequence = false)
+    {
+        $compiler->prefixCompiledCode .= "<?php \$_smarty_tpl->ext->_inheritance->init(\$_smarty_tpl, " .
+            var_export($initChildSequence, true) . ");\n?>\n";
+    }
+}
\ No newline at end of file
Index: src/includes/classes/Smarty/plugins/function.html_select_date.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/plugins/function.html_select_date.php	(revision 54b5657ad2e80eb6f9bf910415d8a992a8b6d777)
+++ src/includes/classes/Smarty/plugins/function.html_select_date.php	(revision )
@@ -1,0 +1,0 @@
Index: src/includes/classes/Smarty/sysplugins/smarty_internal_compile_assign.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_compile_assign.php	(revision 54b5657ad2e80eb6f9bf910415d8a992a8b6d777)
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_compile_assign.php	(revision )
@@ -17,22 +17,30 @@
 class Smarty_Internal_Compile_Assign extends Smarty_Internal_CompileBase
 {
     /**
+     * Valid scope names
+     *
+     * @var array
+     */
+    public $valid_scopes = array('local'  => true, 'parent' => true, 'root' => true, 'global' => true,
+                                 'smarty' => true, 'tpl_root' => true);
+
+    /**
      * Compiles code for the {assign} tag
      *
-     * @param  array  $args      array with attributes from parser
+     * @param  array                                $args      array with attributes from parser
-     * @param  object $compiler  compiler object
+     * @param \Smarty_Internal_TemplateCompilerBase $compiler  compiler object
-     * @param  array  $parameter array with compilation parameter
+     * @param  array                                $parameter array with compilation parameter
      *
      * @return string compiled code
+     * @throws \SmartyCompilerException
      */
-    public function compile($args, $compiler, $parameter)
+    public function compile($args, Smarty_Internal_TemplateCompilerBase $compiler, $parameter)
     {
         // the following must be assigned at runtime because it will be overwritten in Smarty_Internal_Compile_Append
         $this->required_attributes = array('var', 'value');
         $this->shorttag_order = array('var', 'value');
-        $this->optional_attributes = array('scope');
+        $this->optional_attributes = array('scope', 'bubble_up');
         $_nocache = 'null';
-        $_scope = Smarty::SCOPE_LOCAL;
         // check and get attributes
         $_attr = $this->getAttributes($compiler, $args);
         // nocache ?
@@ -42,43 +50,47 @@
             if (isset($compiler->template->tpl_vars[trim($_attr['var'], "'")])) {
                 $compiler->template->tpl_vars[trim($_attr['var'], "'")]->nocache = true;
             } else {
-                $compiler->template->tpl_vars[trim($_attr['var'], "'")] = new Smarty_variable(null, true);
+                $compiler->template->tpl_vars[trim($_attr['var'], "'")] = new Smarty_Variable(null, true);
             }
         }
         // scope setup
+        $_scope = Smarty::SCOPE_LOCAL;
         if (isset($_attr['scope'])) {
             $_attr['scope'] = trim($_attr['scope'], "'\"");
+            if (!isset($this->valid_scopes[$_attr['scope']])) {
+                $compiler->trigger_template_error("illegal value '{$_attr['scope']}' for \"scope\" attribute", null, true);
+            }
+            if ($_attr['scope'] != 'local') {
-            if ($_attr['scope'] == 'parent') {
-                $_scope = Smarty::SCOPE_PARENT;
-            } elseif ($_attr['scope'] == 'root') {
-                $_scope = Smarty::SCOPE_ROOT;
-            } elseif ($_attr['scope'] == 'global') {
-                $_scope = Smarty::SCOPE_GLOBAL;
+                if ($_attr['scope'] == 'parent') {
+                    $_scope = Smarty::SCOPE_PARENT;
+                } elseif ($_attr['scope'] == 'root') {
+                    $_scope = Smarty::SCOPE_ROOT;
+                } elseif ($_attr['scope'] == 'global') {
+                    $_scope = Smarty::SCOPE_GLOBAL;
-            } else {
-                $compiler->trigger_template_error('illegal value for "scope" attribute', $compiler->lex->taglineno);
+                } elseif ($_attr['scope'] == 'smarty') {
+                    $_scope = Smarty::SCOPE_SMARTY;
+                } elseif ($_attr['scope'] == 'tpl_root') {
+                    $_scope = Smarty::SCOPE_TPL_ROOT;
-            }
+                }
+                $_scope += (isset($_attr['bubble_up']) && $_attr['bubble_up'] == 'false') ? 0 : Smarty::SCOPE_BUBBLE_UP;
-        }
+            }
+        }
         // compiled output
         if (isset($parameter['smarty_internal_index'])) {
-            $output = "<?php \$_smarty_tpl->createLocalArrayVariable($_attr[var], $_nocache, $_scope);\n\$_smarty_tpl->tpl_vars[$_attr[var]]->value$parameter[smarty_internal_index] = $_attr[value];";
+            $output =
+                "<?php \$_smarty_tpl->smarty->ext->_var->createLocalArrayVariable(\$_smarty_tpl, $_attr[var], $_nocache);\n\$_smarty_tpl->tpl_vars[$_attr[var]]->value$parameter[smarty_internal_index] = $_attr[value];";
         } else {
             // implement Smarty2's behaviour of variables assigned by reference
             if ($compiler->template->smarty instanceof SmartyBC) {
-                $output = "<?php if (isset(\$_smarty_tpl->tpl_vars[$_attr[var]])) {\$_smarty_tpl->tpl_vars[$_attr[var]] = clone \$_smarty_tpl->tpl_vars[$_attr[var]];";
-                $output .= "\n\$_smarty_tpl->tpl_vars[$_attr[var]]->value = $_attr[value]; \$_smarty_tpl->tpl_vars[$_attr[var]]->nocache = $_nocache; \$_smarty_tpl->tpl_vars[$_attr[var]]->scope = $_scope;";
-                $output .= "\n} else \$_smarty_tpl->tpl_vars[$_attr[var]] = new Smarty_variable($_attr[value], $_nocache, $_scope);";
+                $output =
+                    "<?php if (isset(\$_smarty_tpl->tpl_vars[$_attr[var]])) {\$_smarty_tpl->tpl_vars[$_attr[var]] = clone \$_smarty_tpl->tpl_vars[$_attr[var]];";
+                $output .= "\n\$_smarty_tpl->tpl_vars[$_attr[var]]->value = $_attr[value]; \$_smarty_tpl->tpl_vars[$_attr[var]]->nocache = $_nocache;";
+                $output .= "\n} else \$_smarty_tpl->tpl_vars[$_attr[var]] = new Smarty_Variable($_attr[value], $_nocache);";
             } else {
-                $output = "<?php \$_smarty_tpl->tpl_vars[$_attr[var]] = new Smarty_variable($_attr[value], $_nocache, $_scope);";
+                $output = "<?php \$_smarty_tpl->tpl_vars[$_attr[var]] = new Smarty_Variable($_attr[value], $_nocache);";
             }
         }
-        if ($_scope == Smarty::SCOPE_PARENT) {
-            $output .= "\nif (\$_smarty_tpl->parent != null) \$_smarty_tpl->parent->tpl_vars[$_attr[var]] = clone \$_smarty_tpl->tpl_vars[$_attr[var]];";
-        } elseif ($_scope == Smarty::SCOPE_ROOT || $_scope == Smarty::SCOPE_GLOBAL) {
-            $output .= "\n\$_ptr = \$_smarty_tpl->parent; while (\$_ptr != null) {\$_ptr->tpl_vars[$_attr[var]] = clone \$_smarty_tpl->tpl_vars[$_attr[var]]; \$_ptr = \$_ptr->parent; }";
-        }
-        if ($_scope == Smarty::SCOPE_GLOBAL) {
-            $output .= "\nSmarty::\$global_tpl_vars[$_attr[var]] = clone \$_smarty_tpl->tpl_vars[$_attr[var]];";
-        }
+        $output .= "\n\$_smarty_tpl->ext->_updateScope->updateScope(\$_smarty_tpl, $_attr[var], $_scope);";
         $output .= '?>';
 
         return $output;
